---
title: NavigatorID.userAgent
slug: Web/API/NavigatorID/userAgent
tags:
  - API
  - NavigatorID
  - Property
  - Read-only
  - Reference
---
<p>{{ApiRef("HTML DOM")}}</p>

<p>The <code><strong>NavigatorID.userAgent</strong></code> read-only property returns the user agent string for the current browser.</p>

<div class="note">
<p>The specification asks browsers to provide as little information via this field as possible. Never assume that the value of this property will stay the same in future versions of the same browser. Try not to use it at all, or only for current and past versions of a browser. New browsers may start using the same UA, or part of it, as an older browser: you really have no guarantee that the browser agent is indeed the one advertised by this property.<br>
 <br>
 Also keep in mind that users of a browser can change the value of this field if they want (UA spoofing).</p>
</div>

<p>Browser identification based on detecting the user agent string is <strong>unreliable</strong> and <strong>is not recommended</strong>, as the user agent string is user configurable. For example:</p>

<ul>
 <li>In Firefox, you can change the preference <code>general.useragent.override</code> in <code>about:config</code>. Some Firefox extensions do that; however, this only changes the HTTP header that gets sent, and doesn't affect browser detection performed by JavaScript code.</li>
 <li>Opera 6+ allows users to set the browser identification string via a menu.</li>
 <li>Microsoft Internet Explorer uses the Windows registry.</li>
 <li>Safari and iCab allow users to change the browser user agent string to predefined Internet Explorer or Netscape strings via a menu.</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>ua</var> = navigator.userAgent;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} specifying the complete user agent string the browser provides both in {{Glossary("HTTP")}} headers and in response to this and other related methods on the {{domxref("Navigator")}} object.</p>

<p>The user agent string is built on a formal structure which can be decomposed into several pieces of info. Each of these pieces of info comes from other navigator properties which are also settable by the user. Gecko-based browsers comply with the following general structure:</p>

<pre class="notranslate">userAgent = appCodeName/appVersion number (Platform; Security; OS-or-CPU;
Localization; rv: revision-version-number) product/productSub
Application-Name Application-Name-version
</pre>

<h2 id="Example">Example</h2>

<pre class="brush:js notranslate">alert(window.navigator.userAgent)
// alerts "Mozilla/5.0 (Windows; U; Win98; en-US; rv:0.9.2) Gecko/20010725 Netscape6/6.1"
</pre>

<ul>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-navigator-useragent', 'NavigatorID.userAgent')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.NavigatorID.userAgent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{httpheader("User-Agent")}} HTTP header</li>
</ul>
